Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_FIFO_Caching_Strategy Class Template Reference

The First In First Out strategy is implemented wherein each item is ordered. More...

`#include <Caching_Strategies_T.h>`

Collaboration diagram for ACE_FIFO_Caching_Strategy:

[legend]
List of all members.

## Public Types
typedef ATTRIBUTES | CACHING_ATTRIBUTES
## Public Methods
| ACE_FIFO_Caching_Strategy (void)
| The <container> is the map in which the entries reside. More...
ATTRIBUTES | attributes (void)
| Accessor method. More...
double | purge_percent (void)
| Get the percentage of entries to purge. More...
void | purge_percent (double percentage)
| Set the percentage of entries to purge. More...
int | notify_bind (int result, const ATTRIBUTES &attr)
| Notification for an item getting bound into the cache. More...
int | notify_find (int result, ATTRIBUTES &attr)
| This method acts as a notification about the CONTAINERs find method call. More...
int | notify_unbind (int result, const ATTRIBUTES &attr)
| This method acts as a notification about the CONTAINERs unbind method call. More...
int | notify_trybind (int result, ATTRIBUTES &attr)
| This method acts as a notification about the CONTAINERs trybind method call. More...
int | notify_rebind (int result, const ATTRIBUTES &attr)
| Notification for an item getting bound again into the cache. More...
CACHING_UTILITY & | caching_utility (void)
| Purge the cache. More...
void | dump (void) const
| Dumps the state of the object. More...
## Private Attributes
ATTRIBUTES | order_
| The order is the deciding factor for the item to be removed from the cache. More...
double | purge_percent_
| The level about which the purging will happen automagically. More...
CACHING_UTILITY | caching_utility_
| This is the helper class which will decide and expunge entries from the cache. More...

## Detailed Description

### template<class ATTRIBUTES, class CACHING_UTILITY>
class ACE_FIFO_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >

The First In First Out strategy is implemented wherein each item is ordered.

The order tag of each item is used to decide the item to be removed from the cache. The items with least order are removed. Explanation of the template parameter list: CONTAINER is any map with entries of type <KEY, VALUE>. The ATTRIBUTES are the deciding factor for purging of entries and should logically be included with the VALUE. Some ways of doing this are: As being a member of the VALUE or VALUE being ACE_Pair<x, ATTRIBUTES>. The CACHING_UTILITY is the class which can be plugged in and which decides the entries to purge.

## Member Typedef Documentation

template<class ATTRIBUTES, class CACHING_UTILITY>
typedef ATTRIBUTES ACE_FIFO_Caching_Strategy::CACHING_ATTRIBUTES

## Constructor & Destructor Documentation

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_FIFO_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::ACE_FIFO_Caching_Strategy | ( | void |  | ) |

| The <container> is the map in which the entries reside. The timer attribute is initialed to zero in this constructor. And the <purge_percent> field denotes the percentage of the entries in the cache which can be purged automagically and by default is set to 10%.

## Member Function Documentation

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE ATTRIBUTES ACE_FIFO_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::attributes | ( | void |  | ) |

| Accessor method.

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE CACHING_UTILITY & ACE_FIFO_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::caching_utility | ( | void |  | ) |

| Purge the cache.

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE void ACE_FIFO_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::dump | ( | void |  | ) | const

| Dumps the state of the object.

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE int ACE_FIFO_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::notify_bind | ( | int | result,
|  | const ATTRIBUTES & | attr
| ) |

| Notification for an item getting bound into the cache.

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE int ACE_FIFO_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::notify_find | ( | int | result,
|  | ATTRIBUTES & | attr
| ) |

| This method acts as a notification about the CONTAINERs find method call.

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE int ACE_FIFO_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::notify_rebind | ( | int | result,
|  | const ATTRIBUTES & | attr
| ) |

| Notification for an item getting bound again into the cache.

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE int ACE_FIFO_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::notify_trybind | ( | int | result,
|  | ATTRIBUTES & | attr
| ) |

| This method acts as a notification about the CONTAINERs trybind method call.

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE int ACE_FIFO_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::notify_unbind | ( | int | result,
|  | const ATTRIBUTES & | attr
| ) |

| This method acts as a notification about the CONTAINERs unbind method call.

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE void ACE_FIFO_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::purge_percent | ( | double | percentage | ) |

| Set the percentage of entries to purge.

template<class ATTRIBUTES, class CACHING_UTILITY>
ACE_INLINE double ACE_FIFO_Caching_Strategy< ATTRIBUTES, CACHING_UTILITY >::purge_percent | ( | void |  | ) |

| Get the percentage of entries to purge.

## Member Data Documentation

template<class ATTRIBUTES, class CACHING_UTILITY>
CACHING_UTILITY ACE_FIFO_Caching_Strategy::caching_utility_`[private]`

| This is the helper class which will decide and expunge entries from the cache.

template<class ATTRIBUTES, class CACHING_UTILITY>
ATTRIBUTES ACE_FIFO_Caching_Strategy::order_`[private]`

| The order is the deciding factor for the item to be removed from the cache.

template<class ATTRIBUTES, class CACHING_UTILITY>
double ACE_FIFO_Caching_Strategy::purge_percent_`[private]`

| The level about which the purging will happen automagically.

The documentation for this class was generated from the following files:

- Caching_Strategies_T.h
- Caching_Strategies_T.cpp
- Caching_Strategies_T.i